| Home | Libraries | People | FAQ | More

#### read (8 of 8 overloads)

Attempt to read a certain amount of data from a stream before returning.

    template<
        typename SyncReadStream,
        typename Allocator,
        typename CompletionCondition>
    std::size_t read(
        SyncReadStream & s,
        basic_streambuf< Allocator > & b,
        CompletionCondition completion_condition,
        boost::system::error_code & ec);

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the stream's read_some function.

###### Parameters

s

  The stream from which the data is to be read. The type must support the SyncReadStream concept.

b

  The `basic_streambuf` object into which the data will be read.

completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest read_some operation.
        const boost::system::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the read operation is complete. A non-zero return value indicates the maximum number of bytes to be read on the next call to the stream's read_some function.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes read. If an error occurs, returns the total number of bytes successfully transferred prior to the error.